import React, { useEffect, useRef, useState } from "react";
import { Mic, MicOff } from "react-feather";
import { AudioRecorder } from "jnaudiostream";

class CustomAudioRecorder extends AudioRecorder {
    async startRecording() {
        // console.log("override")
        // console.log(this.options)
        // console.log(this.afterStop)
        // console.log(this.mediaGranted, this.mediaRecorder, this.options.mediaStream)
        // if (this.afterStop) {
        //     this.afterStop = false;

        //     if (!this.options.mediaStream) {
        //         const stream = await navigator.mediaDevices.getUserMedia({
        //             audio: this.options.audio ?? true,
        //         });
        //         this.reAddTracks(stream);
        //     }
        //     return;
        // } else if (!this.mediaGranted || !this.mediaRecorder) {
            this.recordingReady = false;

            // if (this.options.mediaStream) {
            //     this.onMediaGranted(this.options.mediaStream);
            // } else {
                const stream = await navigator.mediaDevices.getUserMedia({
                    audio: this.options.audio ?? true,
                });
                this.onMediaGranted(stream);
            // }

            // return false;
        // }

        if (this.mediaRecorder.state !== "recording") {
            this.mediaRecorder.start(this.latency);
            this.recording = true;
        }

        return true;
    }

    // stopRecording() {
    //     // if (!this.recording || !this.mediaRecorder) {
    //     //     return;
    //     // }

    //     this.recording = false;
    //     // this.mediaRecorder.stop();

    //     if (!this.options.mediaStream) {
    //         // Turn off stream from microphone
    //         var streams = this.mediaRecorder.stream.getTracks();
    //         for (var i = 0; i < streams.length; i++) {
    //             streams[i].stop();
    //             this.mediaRecorder.stream.removeTrack(streams[i]);
    //         }
    //     }

    //     // this.mediaRecorder.ondataavailable = null;
    //     // this.mediaRecorder.onstart = null;

    //     this.bufferHeader = null;

    //     this.afterStop = true;

    //     if (this.onStop) this.onStop();
    // }
}

export default function MicrophoneButton({ socket }) {
    const [recording, setRecording] = useState(false);

    const recorderRef = useRef(new CustomAudioRecorder({}, 100))

    useEffect(() => {
        socket.on("newJoin", (socketId) => {
            if (recorderRef.current.recording) {
                recorderRef.current.stopRecording()
                // console.log("plz")
                recorderRef.current = new CustomAudioRecorder({}, 100);
                setUpRecorder(socketId);
                recorderRef.current.startRecording()
            }
        })
    }, [])

    const setUpRecorder = (socketId) => {

        recorderRef.current.onReady = (packet) => {
            console.log("Recording started!");
            console.log(packet);
            console.log("Header size: " + packet.data.size + "bytes");
            socket.emit("bufferHeader", packet, socketId);
            socket.emit("createRoom");
        };

        recorderRef.current.onBuffer = (packet) => {
            // console.log(777, socketId)
            socket.emit("stream", packet, socketId);
        };
    }

    useEffect(() => {
        if (!socket) return;
        setUpRecorder();
    }, [socket]);

    const onClickMic = () => {
        // setRecording(!recording);
        // console.log(recorderState.recording)
        recording
            ? recorderRef.current.stopRecording()
            : recorderRef.current.startRecording();
        setRecording(!recording);
    };
    

    const Icon = recording ? MicOff : Mic;

    const title = `${recording ? "Stop" : "Start"} recording`;

    return (
        <div className="flex flex-col items-center w-full">
            <button
                type="button"
                title={title}
                onClick={onClickMic}
                className="rounded-full p-5 bg-transparent border-2 border-blue-300 focus:border-red-600 hover:bg-gray-700"
            >
                <Icon size={64} className="color-white" />
            </button>
        </div>
    );
}
