import { AudioStreamer } from "jnaudiostream";
import { useEffect, useRef, useState } from "react";

const useAudioStreamer = (socket, canStart, bufferHeader) => {
    const streamerRef = useRef();
    const [streamerHeader, setStreamerHeader] = useState();

    const updateStreamerHeader = () => {
        const streamer = streamerRef.current;
        // if (!streamerHeader || !streamer || streamer.mediaBuffer) return;
        // console.log("LA:, ", streamerHeader, streamer)
        if (!streamerHeader || !streamer) return
        // console.log(streamer)
        // if (!streamer) return

        streamer.setBufferHeader(streamerHeader);
        if (canStart)
            streamer.playStream();
    };

    useEffect(() => {
        if (!canStart) {
            if (streamerRef.current) streamerRef.current.stop();
            return;
        }

        streamerRef.current = new AudioStreamer();
        const streamer = streamerRef.current;

        // socket.on("bufferHeader", setStreamerHeader)

        // socket.on("bufferHeader", (packet) => {
        //     console.log(444)
        //     setStreamerHeader(packet);
        // })

        // console.log(socket)

        socket.on("stream", (packet) => {
            // if (!streamer.mediaBuffer) {
            //     return;
            // }
            console.log(packet)
            streamer.receiveBuffer(packet);
        });

        updateStreamerHeader()

        return () => {
            // socket.off("bufferHeader");
            // socket.off("stream");
        };
    }, [canStart]);

    useEffect(() => {
        updateStreamerHeader()
    }, [streamerHeader]);

    useEffect(() => {
        console.log(555, bufferHeader)
        if (!bufferHeader) return;
        setStreamerHeader(bufferHeader);
        updateStreamerHeader()
    }, [bufferHeader]);
};

export default useAudioStreamer;
