import { useEffect, useRef, useState } from "react";
import { io } from "socket.io-client";
import useAudioStreamer from "../hooks/useAudioStreamer";
import { Headphones, PhoneOff } from "react-feather";

const URL = "http://localhost:3000";

function Listen() {
    const socketRef = useRef(io(URL));
    const [canPlay, setCanPlay] = useState(false);
    const [bufferHeader, setBufferHeader] = useState();
    // console.log("What are you: ", bufferHeader)
    const audioEl = useRef();
    useAudioStreamer(socketRef.current, canPlay, bufferHeader);

    useEffect(() => {
        // if (!canPlay || audioEl.current === undefined) return;
        // console.log(audioEl.current)
        // audioEl.current.play();
        // console.log(canPlay)
        if (!canPlay) setBufferHeader()
    }, [canPlay]);

    useEffect(() => {
        socketRef.current.on("bufferHeader", (packet) => {
            // console.log(333)
            setBufferHeader(packet);
        })
        socketRef.current.emit("joinRoom")
    }, []);

    const onClickAudio = () => {
        setCanPlay(!canPlay);
    };

    const Icon = canPlay ? PhoneOff : Headphones;

    return (
        <div className="flex flex-col items-center h-full">
            <h1 className="text-5xl font-bold">
                {!canPlay ? "Click to Listen" : "Listening..."}
            </h1>
            <button onClick={onClickAudio} className="rounded-full bg-gray-700 enabled:hover:bg-gray-600 transition-all p-6 mt-5">
                <Icon size={50} />
            </button>
            <audio src={`${URL}/stream`} ref={audioEl} />
        </div>
    );
}

export default Listen;
